
AT103DESTR = NewATMainDestructor

;==========================================================
ATXPROC AT103MAIN
;==========================================================
; Note: CGun object contains a current Ammo value and a MaxAmmo value.
; MaxAmmo=DWORD [obj+68h] ; Ammo=DWORD [obj+6Ch]
; Note2: object that contains two active CGun objects stores them at
; offsets 0E34h and 0E38h from the start of the object (for the currently
; held and currently holstered weapons, respectively)

; UPDATE (07/05/2006): Offset 0E38h for secondary weapon is only valid
; when the weapon is small, i.e., holstered to Anne's waist. If the weapon
; is larger, its instanced will be stored at 0E3Ch. Both must be verified
; when accessing a possible secondary weapon.

push edi
push ebx
push esi

	cmp [ecx+CAT103.ReloadsLeft],0
	jz .nomorereloads

	mov edi,ecx

	xor ebx,ebx

	mov eax,[ACTIVE_GUN_REF_ADDR]
	mov edx,[eax]

	mov eax,[edx]
	mov ecx,[eax+08h]

	mov edx,[ecx+GETWEAPON_PRIMARY] 				; edx = possible primary CGun object
	mov al,1							; check for 'hand' gun
	call AT103VerifyReload

	mov edx,[ecx+GETWEAPON_SECONDARYWAIST]				; edx = possible secondary CGun object
	mov al,2							; check for holstered gun (at waist)
	call AT103VerifyReload
	mov edx,[ecx+GETWEAPON_SECONDARYBACK]				; edx = possible secondary CGun object
	mov al,2							; check for holstered gun (one Anne's back)
	call AT103VerifyReload

	cmp [edi+CAT103.ReloadsLeft],AT103_INFINITE_RELOADS
	jz @f

		sub [edi+CAT103.ReloadsLeft],ebx			; only decrease reload count if a reload happened

	@@:

.nomorereloads:
pop esi
pop ebx
pop edi
ret

;==========================================================
ATXPROC AT103VerifyReload      ; al = test value to specified weapon
;==========================================================
; this verifies which gun the object specifies the reload
; to apply to and applies if needed using extra values if used

	test edx,edx
	mov esi,[CGUNVTABLE]
	jz .noweapon							; make sure Anne is holding an object
	cmp [edx],esi
	jnz .noweapon							; make sure we have a CGun type object

	test BYTE [edi+CAT103.TargetWeapons],al
	jz .noweapon

   ; if applicable, test if gun instance can receive ammo injection

	cmp [edi+CAT103.NumberOfAllowedGuns],AT103_ALLOW_ALL_GUN_INSTANCES
	jz .allinstances

	push eax
	push ecx
	push edx
	mov eax,[edx+CInstance.InstanceNameID]
	lea edx,[edi+sizeof.CAT103]
	mov ecx,[edi+CAT103.NumberOfAllowedGuns]

	.verifyinstanceloop:
	cmp eax,[edx]
	jz .instanceverified
	add edx,4
	dec ecx
	jnz .verifyinstanceloop
	pop edx
	pop ecx
	pop eax
	jmp .noweapon							; not found
	.instanceverified:

	pop edx
	pop ecx
	pop eax

.allinstances:

	mov eax,[edi+CAT103.Ammo]
	cmp eax,AT103_NO_AMMO_VALUE
	jz .noammovalue
	mov [edx+CGun.AmmoCount],eax
	or ebx,1
	jmp .noweapon

.noammovalue:

	mov eax,[edx+CGun.MaxAmmoCount]
	sub eax,[edi+CAT103.AltAmmoCount]
	mov [edx+CGun.AmmoCount],eax
	or ebx,1

.noweapon:
ret

;==========================================================
ATXPROC AT103_REINIT
;==========================================================

	mov eax,[ecx+CAT103.InitialTotalReloads]
	mov [ecx+CAT103.ReloadsLeft],eax

mov eax,[esp+4] 							; standard
ret 4

