;==========================================================
proc AT110MAIN uses esi edi ebx
;==========================================================
local lpInstance:DWORD, lpSourceInstance:DWORD, tempVector:VECTOR

	mov esi,[FixSMainBuffer]
	test esi,esi
	jz .exit

	mov edi,ecx

	GETINSTANCEFROMID32 [edi+CAT110.InstanceNameID]
	test eax,eax
	jz .destinstancedoesnotexist

	mov [lpInstance],eax
	mov [lpSourceInstance],0

    ; check if we have a source instance, and, if so, get instance!

	mov eax,[edi+CAT110.SourceInstanceNameID]
	test eax,eax
	jz .nosourceinstanceid

		GETINSTANCEFROMID32 eax
		test eax,eax
		jz .sourceinstancedoesnotexist

		mov [lpSourceInstance],eax

	.nosourceinstanceid:


	mov ebx,[FixSMainBufferSizeDiv2]
	mov eax,[edi+CAT110.InstanceNameID]

    ; first, check if this instance name already has an entry in buffer

	.instancenamecheckloop:
	cmp [esi],eax
	jnz @f

		cmp [edi+CAT110.ForceBool],FALSE
		jz .exit
		jmp .copynewstrucdata

	@@:
	add esi,4
	cmp esi,[FixSMainBufferHalfEnd]
	jb .instancenamecheckloop

	mov esi,[FixSMainBuffer]
	xor eax,eax

	.findfreeslotloop:
	cmp [esi],eax
	jz .findfreeslotloopend

	add esi,4
	cmp esi,[FixSMainBufferHalfEnd]
	jb .findfreeslotloop
	jmp .exit
	.findfreeslotloopend:

	invoke LocalAlloc,LPTR,sizeof.AT110_PROJ_INFO
	test eax,eax
	mov [esi+ebx],eax
	jz .exit

	.copynewstrucdata:					; esi = pointer to instance name to store
								; [esi+ebx] = pointer to struct space
	mov eax,[lpSourceInstance]
	mov ebx,[esi+ebx]
	test eax,eax
	jnz .usesourceinstance

		mov eax,[edi+CAT110.Velocity.X]
		mov ecx,[edi+CAT110.Velocity.Y]
		mov edx,[edi+CAT110.Velocity.Z]
		mov [ebx+AT110_PROJ_INFO.Velocity.X],eax
		mov [ebx+AT110_PROJ_INFO.Velocity.Y],ecx
		mov [ebx+AT110_PROJ_INFO.Velocity.Z],edx

	jmp .finalize

	.usesourceinstance:

		lea ecx,[eax+CInstance.OrientationQuat]
		lea edx,[tempVector]
		stdcall CONVERT_TO_FACING_PROC_010,edx,0	; get source instance's orientation

		fld [edi+CAT110.TotalVelocity]			; set (orientationunitvector)*speed
		fld st0
		fmul [tempVector.X]
		fstp [ebx+AT110_PROJ_INFO.Velocity.X]
		fld st0
		fmul [tempVector.Y]
		fstp [ebx+AT110_PROJ_INFO.Velocity.Y]
		fmul [tempVector.Z]
		fstp [ebx+AT110_PROJ_INFO.Velocity.Z]

	.finalize:

	mov eax,[edi+CAT110.Interval]
	mov ecx,[lpInstance]
	mov edx,[edi+CAT110.InstanceNameID]
	mov [ebx+AT110_PROJ_INFO.TickLeft],eax
	mov [ebx+AT110_PROJ_INFO.Instance],ecx			; set instance in struct
	mov [esi],edx						; set instance name ID in first part of buffer

.exit:
ret

.sourceinstancedoesnotexist:
ret

.destinstancedoesnotexist:
ret
endp
