;========================================================
proc SimpleListReset uses esi edi
;========================================================
; ecx = SimpleList instance

	mov esi,ecx

	mov edi,[esi+SIMPLELIST.lpFirstNode]

	.freeallloop:
	test edi,edi
	jz .allfreed

		mov edx,edi
		mov edi,[edi+SIMPLELISTNODE.lpNextNode]

		invoke LocalFree,edx
		jmp .freeallloop

	.allfreed:

	mov [esi+SIMPLELIST.NumNodes],0
	mov [esi+SIMPLELIST.lpFirstNode],0
	mov [esi+SIMPLELIST.lpLastNode],0

ret
endp

;========================================================
proc SimpleListAppend uses ebx esi edi, lpData:DWORD,DataSize:DWORD,Padding:DWORD
;========================================================
; ecx = SimpleList instance
; returns TRUE if success, FALSE otherwise

	mov ebx,ecx

	mov eax,[DataSize]
	add eax,[Padding]
	add eax,sizeof.SIMPLELISTNODE
	invoke LocalAlloc,LMEM_FIXED,eax
	test eax,eax
	jz .error

	mov edi,eax
	mov ecx,[DataSize]
	mov edx,[ebx+SIMPLELIST.lpLastNode]

	add ecx,[Padding]
	mov [edi+SIMPLELISTNODE.lpNextNode],0
	mov [edi+SIMPLELISTNODE.DataSize],ecx

	test edx,edx
	jnz .notempty

		mov [ebx+SIMPLELIST.lpLastNode],edi
		mov [ebx+SIMPLELIST.lpFirstNode],edi
		jmp .docopy

	.notempty:

		mov [edx+SIMPLELISTNODE.lpNextNode],edi
		mov [ebx+SIMPLELIST.lpLastNode],edi

	.docopy:

	mov esi,[lpData]
	lea edi,[edi+sizeof.SIMPLELISTNODE]
	mov ecx,[DataSize]
	shr ecx,2
	rep movsd

	mov ecx,[DataSize]
	and ecx,3
	rep movsb

	mov ecx,[Padding]
	test ecx,ecx
	jz .nopadding

		xor eax,eax
		shr ecx,2
		rep stosd

		mov ecx,[Padding]
		and ecx,3
		rep stosb

	.nopadding:

	inc [ebx+SIMPLELIST.NumNodes]
	mov eax,TRUE

ret

.error:
	xor eax,eax

ret
endp

