;========================================================
ATXPROC GetGameWndInstance
;========================================================
; returns CGameWnd instance ONLY IF is exact instance, else returns null
; destroys eax only
push ecx

	JUMPIFNOCGAMEWND .nogamewnd

pop ecx
ret

.nogamewnd:
	xor eax,eax
pop ecx
ret

;========================================================
ATXPROC GetGameWindowState
;========================================================
; returns combination of GAMESTATE_GAMEWND_ACTIVE and GAMESTATE_CONSOLE_ACTIVE flags in eax
; destroys eax only
push ecx
push edx

	JUMPIFNOCGAMEWND .nogamewnd

	ISCONSOLEON
	test eax,eax
	jz .noconsole

	mov eax,GAMESTATE_GAMEWND_ACTIVE+GAMESTATE_CONSOLE_ENABLED

pop edx
pop ecx
ret

.noconsole:
	mov eax,GAMESTATE_GAMEWND_ACTIVE

pop edx
pop ecx
ret

.nogamewnd:
	xor eax,eax

pop edx
pop ecx
ret



;============================================================
ATXPROC SetInitialLevelTickCount
;============================================================
; saves current tick count as level start tick, with compensation for time spent in menu
; since very first level load (not last level load). Compensation managed by Trespasser functions.

       ; mov [NotInGame_TOTALMENUTIME],0         ; obsolete in ATX 2.06
       ; invoke GetTickCountTRUE                 ;
       ; mov [LevelStart_TICK],eax               ;

	mov ecx,LevelStart_TIMETRACKEROBJ
	call [TIMETRACKER_GETTIMEELAPSED_PROC]		; game sets tick in DWORD [ecx]

ret


;============================================================
ATXPROC GetTickCountINGAME		; returns tick count from level start
;============================================================
; returns tick count from level start, not included time spent in menu (as of
; ATX 2.06, this time is calculated by the game itself and not by ATX)

       ; invoke GetTickCountTRUE                 ; obsolete in ATX 2.06
       ; sub eax,[NotInGame_TOTALMENUTIME]       ;
       ; sub eax,[LevelStart_TICK]               ;

	mov ecx,LevelStart_TIMETRACKEROBJ
	call [TIMETRACKER_GETTIMEELAPSED_PROC]		; game returns time elapsed between current tick
							; and tick at DWORD [ecx], compensating for menu time

ret

; obsolete in ATX 2.06
;;============================================================
;ATXPROC StartInGameMenuTimer
;;============================================================
;; only starts timer if not already not in-game (if in-game)
;
;push eax
;push ecx
;push edx
;
;        invoke GetTickCountTRUE
;        mov [NotInGameStart_TICK],eax
;        mov [NotInGame_BOOL],1
;
;pop edx
;pop ecx
;pop eax
;ret

