;=========================================================
ATXINITPROC write_exe_proc		; writes to exe (in memory; does not modify exe file)
;=========================================================
; edx = destination addr
; ecx = source addr
; esi = number of bytes to write
; eax = addr of var to check for use or not (0 if none)
;       (if [var] is null, no write is performed)
; edi = log file message pointer
; returns 1 in edi if write failed (use "test edi,1" for test)

	push edi				; used by "call WriteLogFile"
	test eax,eax
	mov edi,2
	jz .novarcheck

		cmp DWORD [eax],0
		jz .varnullnowriteexe

	.novarcheck:

	push 0
	invoke WriteProcessMemory,ebx,edx,ecx,esi,esp
	pop ecx
	xor edi,edi

	test eax,eax
	jnz @f

		or edi,1

	@@:

	cmp ecx,esi
	jz @f

		or edi,1

	@@:

	or [DLLLoadSuccessBool],edi

	.varnullnowriteexe:

	push edi
	call WriteLogFile			; param 2 already pushed

ret

;==========================================================
ATXINITPROC CreateLogFile
;==========================================================
push ebx

	invoke CreateFile,atxlogfilepath_const,GENERIC_WRITE,0,0,CREATE_ALWAYS,\
			  FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	jz .error

	mov ebx,eax
	invoke SetFilePointer,eax,0,0,FILE_BEGIN

	sub esp,4
	mov ecx,esp
	invoke WriteFile,ebx,_log_title,_log_title.size,ecx,0
	add esp,4
	test eax,eax
	jz .errorclose

	invoke CloseHandle,ebx

pop ebx
ret

.errorclose:

	invoke CloseHandle,ebx

.error:

	or [DLLLoadSuccessBool],1

pop ebx
ret

;==========================================================
ATXINITPROC WriteLogFile	; [esp+4]=0-SUCCESS,1-FAIL,2-N/A; [esp+8]=string to print
;==========================================================
; WARNING: Do not use lightly! Automatically causes ATYPEX.dll load failure
; if param1 is set to FAIL (1)

cmp DWORD [esp+8],0
jz .exit

push eax
push ecx
push edx
push ebx
push edi

	invoke CreateFile,atxlogfilepath_const,GENERIC_WRITE,0,0,OPEN_ALWAYS,\
			  FILE_ATTRIBUTE_NORMAL,0
	cmp eax,-1
	jz .error

	mov ebx,eax

	invoke SetFilePointer,eax,0,0,FILE_END

	mov edi,[esp+28]
	xor al,al
	or ecx,0FFFFFFFFh
	repnz scasb
	dec edi
	mov eax,[esp+28]

	sub esp,4
	sub edi,eax
	mov ecx,esp

	invoke WriteFile,ebx,eax,edi,ecx,0
	add esp,4
	test eax,eax
	jz .errorclose

	mov eax,[esp+24]
	mov edi,_log_pass
	test eax,eax
	jz .pass

		mov edi,_log_fail
		cmp eax,1
		jz .fail

			mov edi,_log_na

		.fail:

	.pass:

	sub esp,4
	mov ecx,esp
	invoke WriteFile,ebx,edi,12,ecx,0
	add esp,4
	test eax,eax
	jz .errorclose

	invoke CloseHandle,ebx

pop edi
pop ebx
pop edx
pop ecx
pop eax

.exit:
ret 8

.errorclose:

	invoke CloseHandle,ebx

.error:

	or [DLLLoadSuccessBool],1

pop edi
pop ebx
pop edx
pop ecx
pop eax
ret 8

