;============================================================
MACRO RCALL releaseproc, param1 {
;============================================================
; Invokes given function if param is non-zero and passes param to.
; Must be a one-param stdcall proc.

      local .nofree

	cmp param1,0
	    jz .nofree

		invoke releaseproc,param1
		mov param1,0

	.nofree:

      }


;============================================================
MACRO LOCALRELEASE buffer1 {
;============================================================
      local .nofree

	cmp buffer1,0
	    jz .nofree

		invoke LocalFree,buffer1
		mov buffer1,0

	.nofree:

      }

;============================================================
MACRO LOCALRELEASENONULL buffer1 {
;============================================================
      local .nofree

	cmp buffer1,0
	    jz .nofree

		invoke LocalFree,buffer1

	.nofree:

      }

;============================================================
macro HEAPALLOC numbytes {
;============================================================

	invoke HeapAlloc,[ProcHeapHandle],0,numbytes

      }

;============================================================
macro HEAPFREE lpAddr {
;============================================================

	invoke HeapAlloc,[ProcHeapHandle],0,lpAddr

      }


;============================================================
MACRO VIRTUALRELEASE buffer1  {
;============================================================
      local .nofree

	cmp buffer1,0
	    jz .nofree

		invoke VirtualFree,buffer1,0,MEM_RELEASE
		mov buffer1,0

	.nofree:

      }

;============================================================
MACRO VIRTUALRELEASENONULL buffer1  {
;============================================================
      local .nofree

	cmp buffer1,0
	    jz .nofree

		invoke VirtualFree,buffer1,0,MEM_RELEASE

	.nofree:

      }

;============================================================
MACRO ZEROMEM { 	; ecx = number of bytes, edi = buffer
;============================================================
      local .noddtransfer,.nodbtransfer

	mov edx,ecx
	test ecx,0FFFFFFFCh
	     jz .noddtransfer

		xor eax,eax
		shr ecx,2
		rep stosd

	.noddtransfer:

	and edx,3
	    jz .nodbtransfer

		mov ecx,edx
		rep stosb

	.nodbtransfer:

      }
