;============================================================
; PLUGIN SYSTEM EXPORTED FUNCTION DEFINITIONS
;============================================================

;============================================================
proc ATXCCameraTeleport lpLocOrient
;============================================================


	mov edx,[lpLocOrient]
	test edx,edx
	     jz .fail

	GETCCAMERAINSTANCECHECK ecx,.fail

	stdcall CCameraTeleport

	mov eax,TRUE
ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXChangePlayerAIType newAIType
;============================================================

	GETCPLAYERPRIVINSTANCE eax
	mov edx,[newAIType]
	test eax,eax
	     jz .fail

	cmp edx,AITYPE_PLAYER
	    jz .aitypeok
	cmp edx,AITYPE_NULL
	    jz .aitypeok
	cmp edx,AITYPE_ATX_PLAYER_TOGGLE
	    jnz .fail

	.aitypeok:

	stdcall ChangePlayerPrivAIType,edx

	mov eax,TRUE
ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXConvert3DPixelTo2DRender lpCoordinates, lpPos
;============================================================

	GETCCAMERAINSTANCECHECK eax,.fail

	mov ecx,[lpPos]
	mov edx,[lpCoordinates]

	test ecx,ecx
	     jz .fail
	test edx,edx
	     jz .fail

	stdcall Convert3DPixelTo2DRender

ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXDisableInGameKeys
;============================================================

	stdcall DisableInGameKeys
	mov eax,TRUE
ret
endp

;============================================================
proc ATXDisableInGameMvtKeys
;============================================================

	stdcall DisableInGameMvtKeys
	mov eax,TRUE
ret
endp

;============================================================
proc ATXEnableInGameKeys
;============================================================

	stdcall EnableInGameKeys
	mov eax,TRUE
ret
endp

;============================================================
proc ATXFindNextSaveGameFileName lpResult
;============================================================

	mov edx,[lpResult]
	test edx,edx
	     jz .fail

	stdcall FindNextSaveGameFileName,edx

	mov eax,TRUE
ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXGameMemDelete lpMemToFree
;============================================================

	mov edx,[lpMemToFree]
	test edx,edx
	     jz .fail

	ccall [free],edx

	mov eax,TRUE
ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXGameMemNew numBytesToAlloc
;============================================================
; returns mem* in eax or null

	mov edx,[numBytesToAlloc]
	test edx,edx
	     jz .fail

	ccall [YAPAXI],edx

ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXGetAllCAnimalInstances uses esi edi, lpAnimalsTable
;============================================================

	mov esi,[CAnimalBuffer]
	test esi,esi
	     jz .fail

	mov edi,[lpAnimalsTable]
	test edi,edi
	     jz .fail

	mov ecx,[CAnimalInstanceCount]

	.fetchloop:
	mov eax,[esi+CANIMAL_INFO.Instance]
	mov [edi],eax
	add esi,sizeof.CANIMAL_INFO
	add edi,4
	dec ecx
	    jnz .fetchloop

	mov eax,TRUE

ret

.fail:

	xor eax,eax

ret
endp

;============================================================
proc ATXGetAnimateHealth lpInstance
;============================================================

	mov eax,[lpInstance]
	test eax,eax
	     jz .fail

	lea eax,[eax+CAnimal.HitPoints]

.fail:
ret
endp

;============================================================
proc ATXGetBackBufferSurfaceDC
;============================================================

	mov eax,[DDSURFACE_BASE_ADDR]
	mov ecx,[eax]

	test ecx,ecx
	     jz .fail

	call [GetDDSurfaceDCProc]		; GetDC for DDraw surface via EXE

ret

.fail:

	xor eax,eax

ret
endp


;============================================================
proc ATXGetCAISystemInstance
;============================================================

	GETCAISYSTEMINSTANCE eax

ret
endp


;============================================================
proc ATXGetCAnimalInstanceCount
;============================================================

	call GetCAnimalInstanceCount

ret
endp

;============================================================
proc ATXGetCCameraInstance
;============================================================

	GETCCAMERAINSTANCECHECK eax,.fail

ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXGetCParticlesFromID32 particlesID
;============================================================

	mov edx,[particlesID]
	test edx,edx
	     jz .fail

	ccall [CParticlesGetObjProc],edx,0

ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXGetCParticlesID32FromString lpTypeName
;============================================================

	mov eax,[lpTypeName]
	test eax,eax
	     jz .fail

	ccall [CParticlesEncodeNameProc],eax

.fail:
ret
endp



;============================================================
proc ATXGetCPlayerPrivInstance
;============================================================

	GETCPLAYERPRIVINSTANCE eax

ret
endp

;============================================================
proc ATXGetCurrentBitingAnimal
;============================================================

	call GetCurrentOnActBiteAnimalInfo

ret
endp

;============================================================
proc ATXGetDDrawObjectInGame
;============================================================
; returns DDraw object or null

	stdcall GetInGameTresDDrawObject

ret
endp

;============================================================
proc ATXGetDDSurfaceStructSize
;============================================================

	stdcall GetDDSurfaceStructSize

ret
endp

;============================================================
proc ATXGetDDrawSurfaceCurrent
;============================================================

	GETBBSURFACEOBJNONULL eax

ret
endp

;============================================================
proc ATXGetDDScreenDimensions
;============================================================

	GETBBSURFACEDIMENSIONS eax

ret
endp


;============================================================
proc ATXGetEXEType
;============================================================

	mov eax,[EXEID]

ret
endp

;============================================================
proc ATXGetGameDifficulty
;============================================================

	mov eax,[GameDifficultyValue]
	cmp eax,5
	    jb @f

		mov eax,2

	@@:

ret
endp

;============================================================
proc ATXGetGameSpeed
;============================================================
; returns pointer to

	GETGAMESPEEDVALUEADDR eax

ret
endp

;============================================================
proc ATXGetGravity
;============================================================
; returns pointer to

	GETGRAVITYVALUEADDR eax

ret
endp

;============================================================
proc ATXGetHeldWeaponInstance weaponOffset
;============================================================

	mov ecx,[weaponOffset]
	stdcall GetHeldWeaponInstance

ret
endp

;============================================================
proc ATXGetINIFloatEntry sectionName, keyName, defaultValStr, iniPath
;============================================================

	stdcall GetINIFloat,[sectionName],[keyName],[defaultValStr],[iniPath]
	mov [esp-4],eax
	fld DWORD [esp-4]

ret
endp

;============================================================
proc ATXGetInstanceFromID32 instanceID
;============================================================

	mov eax,[instanceID]
	GETINSTANCEFROMID32 eax

ret
endp

;============================================================
proc ATXGetInstanceFromString lpName
;============================================================

	mov eax,[lpName]
	call GetInstanceFromStringGlobal

ret
endp

;============================================================
proc ATXGetInstanceFromStringCBD lpName
;============================================================

	mov eax,[lpName]
	call GetInstanceFromStringGlobal_CBD

ret
endp

;============================================================
proc ATXGetInstanceID32 lpInstance
;============================================================

	mov edx,[lpInstance]
	test edx,edx
	     jz .fail

	mov eax,[edx+CInstance.InstanceNameID]

ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXGetInstanceID32FromString lpInstName
;============================================================

	mov eax,[lpInstName]
	GETNAMEID32STD eax

ret
endp

;============================================================
proc ATXGetInstanceLocation lpInstance
;============================================================

	mov eax,[lpInstance]
	test eax,eax
	     jz .fail

	lea eax,[eax+CInstance.Location]

.fail:
ret
endp

;============================================================
proc ATXGetInstancePhysicsVelocity lpResult, lpInstance
;============================================================
; returns TRUE if object active, FALSE if inactive

	mov ecx,[lpResult]
	mov edx,[lpInstance]
	test ecx,ecx
	     jz .fail
	test edx,edx
	     jz .fail

	GETINSTANCEVELOCITYVALUES ecx,edx

ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXGetLevelSavedSceneName
;============================================================
; returns TRUE if object active, FALSE if inactive

	GETLEVELCURRENTSCNNAME eax

ret
endp

;============================================================
proc ATXGetPlayerAIType
;============================================================
; returns TRUE if object active, FALSE if inactive

	GETCPLAYERPRIVINSTANCE eax
	test eax,eax
	     jz .fail

	stdcall GetPlayerPrivAIType

ret

.fail:
	xor eax,eax
ret
endp


;============================================================
proc ATXGetTimeSinceLastLevelLoad
;============================================================

	stdcall GetTickCountINGAME
ret
endp

;============================================================
proc ATXIsPlayerHoldingGun
;============================================================
; returns CGun instance or NULL

	stdcall IsPlayerHoldingCGun

ret
endp

;============================================================
proc ATXIsValidInstance lpMem, memSize
;============================================================

	stdcall IsValidInstance,[lpMem],[memSize]

ret
endp

;============================================================
proc ATXNewATAllocInstance memSize, lpDestructor, lpMainProc, lpReInitProc
;============================================================
; returns pointer to memory after header or NULL

	cmp [lpMainProc],0
	jz .fail

	mov eax,[memSize]
	cmp eax,0
	jle .fail

	add eax,sizeof.PLUGIN_NEWAT_HEADER
	cinvoke YAPAXI,eax
	test eax,eax
	jz .fail2

	mov [eax+PLUGIN_NEWAT_HEADER.lpVTable],PLUGINAT
	mov [eax+PLUGIN_NEWAT_HEADER.refCount],0
	mov ecx,[lpDestructor]
	mov edx,[lpMainProc]
	mov [eax+PLUGIN_NEWAT_HEADER.lpDestr],ecx
	mov [eax+PLUGIN_NEWAT_HEADER.lpMainProc],edx
	mov ecx,[lpReInitProc]
	mov [eax+PLUGIN_NEWAT_HEADER.lpReInitProc],ecx

	lea eax,[eax+sizeof.PLUGIN_NEWAT_HEADER]

ret

.fail:

	xor eax,eax

.fail2:

ret
endp

;============================================================
proc ATXNewATFreeInstance lpThis
;============================================================

	mov ecx,[lpThis]
	test ecx,ecx
	jz .fail

	lea ecx,[ecx-sizeof.PLUGIN_NEWAT_HEADER]
	cinvoke free,ecx

	mov eax,TRUE
ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXNewATGetGroupValue lpFarReturnGroupObject, valueNameIndex, lpSourceObject, lpEntryCount
;============================================================
; returns TRUE if group found and valid, FALSE otherwise

	mov edx,[valueNameIndex]
	mov eax,[LastScriptIDTableAddr]
	cmp edx,TSCRIPT_MAX_SCRIPT_INDEX_VALUE
	ja .fail

	lea edx,[eax+8*edx+2A8h]

	cinvoke GetGroupIDValueProc,[lpFarReturnGroupObject],edx,[lpSourceObject],\
				    [LastCValueTableInst],[lpEntryCount]

ret

.fail:
	xor eax,eax
ret
endp

;============================================================
proc ATXNewATGetScriptValue valueNameIndex, lpSourceObject, entryNum, valueType
;============================================================
; returns pointer to value of given type or NULL if not found/error

	mov edx,[valueNameIndex]
	mov eax,[LastScriptIDTableAddr]
	cmp edx,TSCRIPT_MAX_SCRIPT_INDEX_VALUE
	ja .fail

	lea edx,[eax+8*edx+2A8h]

	cinvoke GetEntryValueProc,edx,[lpSourceObject],[LastCValueTableInst],[entryNum]
	test eax,eax
	jz .fail2

	mov ecx,[valueType]
	mov edx,[eax+4]
	cmp edx,ecx
	jnz .fail

	cmp ecx,TSCRIPT_VALUETYPE_STRING
	jz .stringvalue

.othervalue:

	lea eax,[eax+28h]

ret

.stringvalue:

	mov eax,[eax+40h]

ret

.fail:

	xor eax,eax

.fail2:

ret
endp

;============================================================
proc ATXReleaseBackBufferSurfaceDC hDC
;============================================================

	mov edx,[hDC]
	test edx,edx
	     jz .fail

	mov eax,[DDSURFACE_BASE_ADDR]
	push edx				; DDraw ReleaseDC
	mov ecx,[eax]
	call [ReleaseDDSurfaceDCProc]

ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXResetCCameraPlayerSources
;============================================================

	GETCCAMERAINSTANCECHECK ecx,.fail
	GETCPLAYERPRIVINSTANCE eax
	test eax,eax
	     jz .fail

	stdcall ResetCCameraPlayerSources

	mov eax,TRUE
ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXSeedParticleEffect lpEffect, lpLocation, lpDirection, param7D, pThreshold
;============================================================

	mov ecx,[lpEffect]		 ; 'this'
	test ecx,ecx
	     jz .fail

	mov eax,[lpLocation]
	mov edx,[lpDirection]

	test eax,eax
	     jz .fail

	test edx,edx
	     jz .fail

	stdcall [CParticlesDoEffectProc],[eax+LOCATION.X],[eax+LOCATION.Y],[eax+LOCATION.Z],\
					 [edx+VECTOR.X],[edx+VECTOR.Y],[edx+VECTOR.Z],\
					 [param7D],[pThreshold]


ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXSetAnimateHealth lpInstance, newHealth
;============================================================

	mov ecx,[lpInstance]
	test ecx,ecx
	     jz .fail

	mov eax,[newHealth]
	mov [ecx+CAnimate.HitPoints],eax

ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXSetAnimateMaxHealth lpInstance, newMaxHealth
;============================================================

	mov ecx,[lpInstance]
	test ecx,ecx
	     jz .fail

	mov eax,[newMaxHealth]
	mov [ecx+CAnimate.MaxHitPoints],eax

ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXSetGameSpeed newGameSpeed
;============================================================

	mov eax,[newGameSpeed]
	GETGAMESPEEDVALUEADDR edx
	mov [edx],eax

ret
endp


;============================================================
proc ATXSetInstanceLocation lpInstance, lpLoc
;============================================================

	mov ecx,[lpInstance]
	mov edx,[lpLoc]

	test ecx,ecx
	     jz .fail

	test edx,edx
	     jz .fail

	mov eax,[ecx]
	push 0
	push edx
	call [eax+ICInstance.Teleport]

ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXSetInstancePhysicsUnfreezeOnly lpInstance
;============================================================

	mov eax,[lpInstance]
	test eax,eax
	     jz .fail

	stdcall SetInstancePhysicsUnfreezeOnly,eax

.fail:
ret
endp

;============================================================
proc ATXSetInstancePhysicsVelocity lpInstance, lpVelRot
;============================================================

	mov ecx,[lpInstance]
	mov edx,[lpVelRot]

	test ecx,ecx
	     jz .fail

	test edx,edx
	     jz .fail

	stdcall SetInstancePhysicsVelocity,ecx,edx


ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXTestExport lpMessage
;============================================================

	mov ecx,[lpMessage]
	test ecx,ecx
	     jz .fail


	SHOWTEMPMESSAGE ecx

	mov eax,TRUE

ret

.fail:
	xor eax,eax

ret
endp

;============================================================
proc ATXWriteLogFile lpText, textSize
;============================================================

	mov eax,[lpText]
	test eax,eax
	     jz .fail

	stdcall WriteLogFileInGame,eax,[textSize]

.fail:
ret
endp
