;========================================================
INTERCEPTPROC FLYDIVERTEDPOSUPDATEINTERCEPT
;========================================================
; main code for FLY cheat

	cmp [FlyModeEnabled],0
	    jz .noforcedposupdate

	mov edx,[esp+4]
	mov eax,[FlyLastXPosition]
	mov [edx],eax
	mov eax,[FlyLastYPosition]
	mov [edx+4h],eax
	mov eax,[FlyLastZPosition]
	mov [edx+8h],eax

	.noforcedposupdate:

jmp [TrueChangePlayerPosMethod]

;========================================================
ATXPROC TestForFlyModeKeys
;========================================================

	JUMPIFNOTGAMEPLAY .exit

	invoke GetTickCount
	mov edx,eax
	sub eax,[FlyKeyLastTick]
	mov ecx,[UseFlyKeyDelay]
	cmp eax,ecx
	    jb .exit

; note: Low framerate movement compensation may produce sudden
; bursts if keys are pressed right after a slowdown. This could
; be remedied by saving key state after every frame at end
; of this code and comparing current key states (after slowdown)
; with last known key state (before slowdown). However, this
; would not help if a key is pressed _during_ slowdown, only if
; pressed right before (so no real solution).

	push eax
	mov [FlyKeyLastTick],edx
	fild DWORD [esp]
	fmul [UseFlyKeyDelayReciprocal] 			; elapsedtime*(1/flykeydelay)

	fmul [UseFlySpeed]					; (elapsedtime/flykeydelay)*flyspeed
	fst [FlySpeedTemp]
	fmul [float_two]
	fstp [FlySpeedTempFast]
	add esp,4

	mov edi,[KEY_LIST_ADDR]

	invoke GetAsyncKeyState,[edi+80]
	push MovePlayerForward_Fast
	call Modify_PositionValues

	invoke GetAsyncKeyState,[edi+88]
	push MovePlayerForward_Slow
	call Modify_PositionValues

	invoke GetAsyncKeyState,[edi+96]
	push MovePlayerBackward
	call Modify_PositionValues

	invoke GetAsyncKeyState,[edi+104]
	push MovePlayerSidewaysLeft
	call Modify_PositionValues

	invoke GetAsyncKeyState,[edi+112]
	push MovePlayerSidewaysRight
	call Modify_PositionValues

	invoke GetAsyncKeyState,[edi+40]
	push MovePlayerUp
	call Modify_PositionValues

	invoke GetAsyncKeyState,[edi+48]
	push MovePlayerDown
	call Modify_PositionValues

.exit:
ret

;========================================================
ATXPROC Modify_PositionValues		; [esp+4]=proc to call, eax=most sign. bit set if go
;========================================================

	test eax,80000000h
	     jz .exit

	GETCCAMERAINSTANCE edx

	push esi
	push edi
	lea esi,[edx+30h]
	mov edi,TempFlyBuffer
	mov ecx,8
	rep movsd
	pop edi
	pop esi

	mov edx,TempFlyBuffer3
	lea ecx,[TempFlyBuffer+0Ch]				; most likely
	push edx
	push TempFlyBuffer2					; param 1 = dest for values (returned in eax)

	call CONVERT_TO_FACING_PROC_010
	;call DWORD [CONVERT_TO_FACING_PROC]                    ; 2 params

	mov ecx,eax						; TempFlyBuffer2
	call DWORD [esp+4]					; MODIFY PLAYER POSITION VALUES

.exit:
ret 4


; the following code would have been used to update the player's position
; as soon as the position values are changed via GetAsyncKeyState checks. However,
; it does not function 100% properly in this form, and the call is made repeatedly
; by the game itself; it is thus not required at all.

;        GETCCAMERAINSTANCE edx
;
;        push esi
;        lea esi,[edx+3Ch]
;        mov edi,TempFlyBuffer+12
;        mov ecx,5
;        rep movsd
;        pop esi
;
;        mov ecx,TempFlyBuffer
;        mov eax,[FlyLastXPosition]
;        mov [ecx],eax
;        mov eax,[FlyLastYPosition]
;        mov [ecx+4],eax
;        mov eax,[FlyLastZPosition]
;        mov [ecx+8],eax
;
;        mov eax,[edx]
;        push 0
;        mov ecx,edx
;        push TempFlyBuffer
;        call DWORD [eax+38h]    ;update position
;
;ret 4

;========================================================
ATXPROC MovePlayerForward_Fast
;========================================================
; ecx=pointer to 3 facing values x,y,z (VECTOR COMPONENTS)

	fld [FlySpeedTempFast]
	fld DWORD [ecx+8]
	fmul st0,st1
	fadd [FlyLastZPosition]
	fstp [FlyLastZPosition]

	fld DWORD [ecx+4]					; Y facing value
	fmul st0,st1
	fadd [FlyLastYPosition]
	fstp [FlyLastYPosition]

	fld DWORD [ecx] 					; X facing value
	fmulp st1,st0
	fadd DWORD [FlyLastXPosition]
	fstp DWORD [FlyLastXPosition]

ret

;========================================================
ATXPROC MovePlayerForward_Slow
;========================================================
; ecx=pointer to 3 facing values x,y,z

	fld [FlySpeedTemp]
	fld DWORD [ecx+8]
	fmul st0,st1
	fadd [FlyLastZPosition]
	fstp [FlyLastZPosition]

	fld DWORD [ecx+4]					; Y facing value
	fmul st0,st1
	fadd [FlyLastYPosition]
	fstp [FlyLastYPosition]

	fld DWORD [ecx] 					; X facing value
	fmulp st1,st0
	fadd DWORD [FlyLastXPosition]
	fstp DWORD [FlyLastXPosition]

ret

;========================================================
ATXPROC MovePlayerBackward
;========================================================
; ecx=pointer to 3 facing values x,y,z

	fld [FlySpeedTemp]
	fld DWORD [ecx+8]
	fmul st0,st1
	fsubr [FlyLastZPosition]
	fstp [FlyLastZPosition]

	fld DWORD [ecx+4]					; Y facing value
	fmul st0,st1
	fsubr [FlyLastYPosition]
	fstp [FlyLastYPosition]

	fld DWORD [ecx] 					; X facing value
	fmulp st1,st0
	fsubr DWORD [FlyLastXPosition]
	fstp DWORD [FlyLastXPosition]

ret

;========================================================
ATXPROC MovePlayerSidewaysLeft
;========================================================
; calculates sideways-left vector (z component null)
; ecx=pointer to 3 facing values x,y,z
; (not optimized)
; from vector multiplication with z axis (0,0,1), we gather that
; left mvt vector = (-y facing, +x facing)
; (must be normalized because xyz facing can  have a z component)

	fld DWORD [ecx+4]					; Y facing value
	fmul st0,st0						; (Y vector)^2
	fld DWORD [ecx] 					; X facing value
	fmul st0,st0						; (X vector)^2
	faddp st1,st0						; (Y vector)^2 + (X vector)^2
	fsqrt							; sqrt((Y vector)^2 + (X vector)^2)
								; note: this should never to null because view angle is limited in Trespasser

	fld DWORD [ecx+4]					; Y facing value
	fdiv st0,st1						; Y vector / vector length
	fmul [FlySpeedTemp]
	fsubr [FlyLastXPosition]
	fstp [FlyLastXPosition]

	fld DWORD [ecx] 					; X facing value
	fdivrp st1,st0						; X vector / vector length
	fmul [FlySpeedTemp]
	fadd [FlyLastYPosition]
	fstp [FlyLastYPosition]

ret

;========================================================
ATXPROC MovePlayerSidewaysRight
;========================================================
; ecx=pointer to 3 facing values x,y,z
; calculates sideways-right vector (z component null)
; from vector multiplication with z axis (0,0,1), we gather that
; right mvt vector = (+y facing, -x facing)
; (must be normalized because xyz facing can  have a z component)

	fld DWORD [ecx+4]					; Y facing value
	fmul st0,st0						; (Y vector)^2
	fld DWORD [ecx] 					; X facing value
	fmul st0,st0						; (X vector)^2
	faddp st1,st0						; (Y vector)^2 + (X vector)^2
	fsqrt							; sqrt((Y vector)^2 + (X vector)^2)
								; note: this should never to null because view angle is limited in Trespasser

	fld DWORD [ecx+4]					; Y facing value
	fdiv st0,st1						; Y vector / vector length
	fmul [FlySpeedTemp]
	fadd [FlyLastXPosition]
	fstp [FlyLastXPosition]

	fld DWORD [ecx] 					; X facing value
	fdivrp st1,st0						; X vector / vector length
	fmul [FlySpeedTemp]
	fsubr [FlyLastYPosition]
	fstp [FlyLastYPosition]

ret

;========================================================
ATXPROC MovePlayerUp
;========================================================

	fld [FlyLastZPosition]
	fadd [FlySpeedTemp]
	fstp [FlyLastZPosition]

ret

;========================================================
ATXPROC MovePlayerDown
;========================================================

	fld [FlyLastZPosition]
	fsub [FlySpeedTemp]
	fstp [FlyLastZPosition]

ret

;========================================================
ATXPROC FLY_Exit_Teleport
;========================================================

	mov [FlyExitQueued],0
	mov edx,FlyExitQueuedBuffer
	call CCameraTeleport

ret


