;===========================================================
CHEATPROC VIDEOCAPTURETOGGLE
;===========================================================
; REC cheat (un-)initialization

	cmp [VideoEnabledBool],1
	    jz .endcapture

	test esi,esi
	    jz .novideoname

; set initial variables

	push esi
	push edi
	mov edi,recvideonamebuf
	call TransferString

	mov DWORD [edi],'.rec'
	test [NewSaveMethod],SAVE_METHOD_NONE
	     jz @f
	mov DWORD [edi],'.wav'
	@@:

	mov BYTE [edi+4],0
	pop edi
	pop esi

	push esi
	push edi
	mov edi,mcistr_savename_buf
	call TransferString
	mov DWORD [edi],'.wav'
	mov BYTE [edi+4],0
	pop edi
	pop esi

; make sure SaveMethod value is valid

	mov eax,[NewSaveMethod]
	mov edx,ValidSaveMethodsTable
	mov ecx,(ValidSaveMethodsTable_END-ValidSaveMethodsTable)/4

	.checksavemethodnumloop:
	cmp eax,[edx]
	    jz .savemethodnumvalid
	add edx,4
	loop .checksavemethodnumloop

	mov edi,rv_error_A
	jmp .capturestarterror

	.savemethodnumvalid:

; no video capture (possibly audio only)?

	test [NewSaveMethod],SAVE_METHOD_NONE
	     jnz .savemethodnone

	xor eax,eax
	mov [VideoEnabledBool],al	 ; ensure recording disabled before starting (in case)
	mov [dibfileheader.TrueFrameCount],eax
	mov [dibfileheader.DiffFrameCount],eax
	mov [dibfileheader.FrameRepCount],eax
	mov [dibfileheader.rv_rt_error_count],eax
	mov [newsavemethodSD.ddpfPixelFormat.dwGBitMask],eax

	mov [dibfileheader.BitmapData.biCompression],BI_RGB
	mov [dibfileheader.BitmapData.biPlanes],1
	mov [dibfileheader.BitmapData.biBitCount],16
	; mov [dibfileheader.BitmapData.biClrUsed],0

	mov eax,[NewSaveMethod]
	cmp eax,SAVE_METHOD_OLD_24
	    jnz @f
	mov [dibfileheader.BitmapData.biBitCount],24
	@@:

	fild [dibfileheader.Framerate]
	fdivr [float_1000]
	fst [vrdef_frametime]
	fist [vrdef_frametime_INT]
	fmul [float_0_001]
	fstp [vrdef_frametimediv1000]

	mov eax,[dibfileheader.BitmapData.biWidth]
	mov ecx,[dibfileheader.BitmapData.biHeight]
	mul ecx
	xor ecx,ecx
	mov cx,[dibfileheader.BitmapData.biBitCount]
	shr ecx,3
	mul ecx
	mov [vrdef_bufsize],eax

; temp frame buffer for new save method

	cmp [NewSaveMethod],SAVE_METHOD_OLD_16
	    jz .notempframebuffer
	cmp [NewSaveMethod],SAVE_METHOD_OLD_24
	    jz .notempframebuffer
	cmp [NewSaveMethod],SAVE_METHOD_NEW_DX
	    jz .notempframebuffer

	invoke VirtualAlloc,0,[vrdef_bufsize],MEM_COMMIT+MEM_RESERVE,PAGE_READWRITE
	test eax,eax
	mov edi,rv_error_9
	    jz .capturestarterror
	mov [newsavetempbuffer],eax

	.notempframebuffer:

; create frame repeat count buffer (256 max repeats for every different frame)

	invoke LocalAlloc,LPTR,[dibfileheader.MaxFrameCount]
	test eax,eax
	mov edi,rv_error_6
	     jz .capturestarterror
	mov [framerepeatcount_BUF],eax

; create main DIB temp file

	cmp [UseRECWriteThrough],FALSE
	mov edx,FILE_FLAG_SEQUENTIAL_SCAN
	    jz @f
	or edx,FILE_FLAG_WRITE_THROUGH
	@@:

	invoke CreateFile,recvideonamebuf,GENERIC_READ+GENERIC_WRITE,0,0,CREATE_ALWAYS,edx,0
	cmp eax,-1
	mov edi,rv_error_7
	    jz .capturestarterror
	mov [dibtempfile_handle],eax

; write initial (mainly empty or invalid) header

	invoke SetFilePointer,[dibtempfile_handle],0,0,FILE_BEGIN

	push 0
	mov ecx,esp
	invoke WriteFile,[dibtempfile_handle],dibfileheader,[dibfileheader.HeaderSize],ecx,0
	pop edx
	test eax,eax
	mov edi,rv_error_8
	     jz .capturestarterror
	cmp edx,[dibfileheader.HeaderSize]
	    jnz .capturestarterror

	mov [DXBLT_FIRST_RUN],TRUE

	.savemethodnone:
	or [VideoEnabledBool],1 				; start recording

jmp EXITCHEATCODE


.capturestarterror:
	call ReleaseAllAVIBuffers
	SHOWTEMPMESSAGE edi
jmp EXITCHEATCODE


.novideoname:
	SHOWTEMPMESSAGE rv_no_spec_file
jmp EXITCHEATCODE


.endcapture:

; MUST SAVE FRAME REPEAT COUNT TO END OF CUSTOM DIB FILE
; AND WRITE FILE HEADER INFO AT START (SPACE PRE-ALLOCATED)

	and [VideoEnabledBool],0
	call EndAudioCapture_REC
	mov eax,[NewSaveMethod]
	test eax,SAVE_METHOD_NONE
	mov edi,rv_encode_success
	     jnz .terminationerror

; fill in header and bitmap info

	mov [dibfileheader.SaveFlags],0
	test eax,SAVE_METHOD_OLD_BOOL
	     jnz @f
	cmp [newsavemethodSD.ddpfPixelFormat.dwGBitMask],07E0h
	    jnz @f
	or [dibfileheader.SaveFlags],PIXEL_FORMAT_16_5_6_5
	@@:

	cmp eax,SAVE_METHOD_NEW_DX
	    jnz @f
	or [dibfileheader.SaveFlags],INVERT_UP_DOWN_IMAGES
	@@:

	mov eax,[vrdef_bufsize]
	; mov [dibfileheader.BitmapData.biSizeImage],eax
	mov ecx,[dibfileheader.DiffFrameCount]
	mul ecx 				; get total size of DIB data
	add eax,[dibfileheader.HeaderSize]	; eax points to EOF
	mov [dibfileheader.FrameRepeatTableFileOffset],eax
	mov [dibfileheader.FrameRepeatTableFileOffsetHigh],edx

; (append frame repeat data to end of file)

; ensure file pointer is put after the DIB data (at EOF)

	push edx
	mov ecx,esp
	invoke SetFilePointer,[dibtempfile_handle],eax,ecx,FILE_BEGIN
	add esp,4

; write the frame repeat buffer data at end of file

	push 0
	mov ecx,esp
	invoke WriteFile,[dibtempfile_handle],[framerepeatcount_BUF],[dibfileheader.DiffFrameCount],ecx,0
	mov edi,rv_error_4
	test eax,eax
	pop ecx
	     jz .terminationerror
	cmp ecx,[dibfileheader.DiffFrameCount]
	    jnz .terminationerror

; write header information to file

	invoke SetFilePointer,[dibtempfile_handle],0,0,FILE_BEGIN

	push 0
	mov ecx,esp
	invoke WriteFile,[dibtempfile_handle],dibfileheader,[dibfileheader.HeaderSize],ecx,0
	mov edi,rv_error_5
	test eax,eax
	pop ecx
	     jz .terminationerror
	cmp ecx,[dibfileheader.HeaderSize]
	    jnz .terminationerror

	mov edi,rv_encode_success


.terminationerror:

	call ReleaseAllAVIBuffers
	SHOWTEMPMESSAGE edi

jmp EXITCHEATCODE
