;==========================================================
; Calculate THIRDP values
;==========================================================
THIRDPInitCode:

; copy default cam distance

	mov eax,[THIRDPDistance]
	mov [THIRDPDistanceOrig],eax

; input rate (min: 5.0)

	fld [THIRDPInputRate]
	fcom [float_5]
	fstsw ax
	test ah,41h
	     jz @f
	     fstp st0
	     fld [float_5]
	@@:
	fdivr [float_1000]
	fistp [THIRDPInputRate]

; default cam angle

	fld [THIRDPCamAngleZ]
	fmul [pidiv180] 				; convert to radians

	fcom [THIRDP_zanglemin]
	fstsw ax
	test ah,1h
	     jz .notlowerthanlimit
	     fstp st0
	     fld [THIRDP_zanglemin]
	     jmp .nothigherthanlimit
	.notlowerthanlimit:

	fcom [THIRDP_zanglemax]
	fstsw ax
	test ah,41h
	     jnz .nothigherthanlimit
	     fstp st0
	     fld [THIRDP_zanglemax]
	.nothigherthanlimit:

	fst [THIRDPCamAngleZ]
	fstp [THIRDPCamAngleZOrig]

; convert cam speed from angles/sec to radians/sec

	fld [THIRDPCamSpeed]
	fmul [pidiv180]
	fstp [THIRDPCamSpeed]

; convert key characters to virtual-key codes

	push edi

	mov edi,THIRDPKeyListStart

	.keytovkinitloop:
	invoke VkKeyScan,[edi]
	and eax,0FFh
	mov [edi],eax
	add edi,4
	cmp edi,THIRDPKeyListEnd
	    jnz .keytovkinitloop

	pop edi


