;============================================================
ATXPROC ATX_QUICKSAVE_RT
;============================================================
push ebx

	invoke GetTickCount
	mov ebx,eax
	sub eax,[QuickSaveTick]
	cmp eax,QUICKSAVE_INTERVAL
	    jb .noquicksave

	mov [QuickSaveSaveDone],0

	invoke GetAsyncKeyState,QUICKSAVE_KEY
	test eax,80000000h
	     jz .noquicksaveb

	call QuickSaveMainProc
	test eax,eax
	mov [QuickSaveTick],ebx
	mov [QuickSaveSaveDone],1
	    jnz @f

		mov [QuickSaveSaveDone],2

	@@:

.noquicksaveb:
pop ebx
ret



.noquicksave:

	cmp [QuickSaveSaveDone],FALSE
	    jz @f

		call DisplayLevelSavedMessageRT

	@@:

pop ebx
ret

;============================================================
ATXPROC DisplayLevelSavedMessageRT
;============================================================

	GETDDSURFACEDC

	mov eax,QUICKSAVE_LEVEL_SAVE_STR
	cmp [QuickSaveSaveDone],2
	mov edx,QUICKSAVE_LEVEL_SAVE_STR.size
	    jnz @f

		mov eax,QUICKSAVE_LEVEL_SAVE_ERR_STR
		mov edx,QUICKSAVE_LEVEL_SAVE_ERR_STR.size

	@@:

	invoke TextOut,edi,0,0,eax,edx

	RELEASEDDSURFACEDC

ret

;============================================================
ATXPROC QuickSaveMainProc		; returns null in eax if error, non-zero if success
;============================================================
; destroyed: eax,ecx,edx

push edi
push esi

; delete current quick save file if existing

	cmp DWORD [QuickSaveCurrentFileName],'none'
	    jz @f

		mov esi,QuickSaveCurrentFileName
		mov edi,[gamedirpathlength]
		add edi,gamedirpath
		call TransferString
		invoke DeleteFile,gamedirpath

	@@:

; get name of savegame that should be created next

	stdcall FindNextSaveGameFileName,QuickSaveCurrentFileName

; save savegame name to ATXconfig.ini

	invoke WritePrivateProfileString,section_gamesaving,key_qscurrentfile,QuickSaveCurrentFileName,atxconfigpath_const

; emulate ActionType 19 to save level

	mov ecx,AT19EmulatedObject
	mov eax,[ecx]
	mov DWORD [ecx+4],0
	mov DWORD [ecx+8],QUICKSAVE_FILE_DISPLAY_NAME_STR.size
	mov DWORD [ecx+0Ch],010h
	mov DWORD [ecx+20h],QUICKSAVE_FILE_DISPLAY_NAME_STR
	call DWORD [eax+8]

	mov eax,1

pop esi
pop edi
ret

