struct CParticleQualities				; all floats
       Number			    dd ?		; default = 8.0
       unknownRadians		    dd ?		; ??? default = 6.283185 (pi*2) **
       Size			    dd ?		; default = 0.01
       Length			    dd ?		; default = 0.04
       Velocity 		    dd ?		; default = 4.0
       Lifespan 		    dd ?		; default = 1.0
       StuckGravity		    dd ?		; default = 1.0 NOT "GravityStuck" ***
       Gravity			    dd ?		; default = 5.0
       SpreadRadians		    dd ?		; default = 1.047198 (radians) - This is the T-Script "Spread" float value converted to radians
       Threshold		    dd ?		; default = 1.0
ends

; ** Don't know what this value controls. Doesn't correspond to any known T-Script value, nor
; used by constructor. Constructor sets it to 0.0 for "Min" value, and pi*2 for "Max" value.
; Presumably in radians.

; *** There is an error in all Trespasser scripts. The "GravityStuck" values
; are actually scanned as "StuckGravity" by the executable, so they have no effect!
; In this case the StuckGravity member becomes the same as the Gravity member, as defined
; by the CParticles constructor.

struct CParticles
       Type			    dd ?		; default = CPARTICLES_TYPE_FLUID
       ColorRGB 		    dd ?		; format: 0x00RRGGBB
       Flags1			    db ?		; ??? default = false
       Log			    db ?		; corresponds to T-Script bool "Log" value - default = true
				    db 2 dup ?		; appears unused
       unknownFloat		    dd ?		; ??? default = 0.25 **
       Priority 		    dd ?		; Int
       Min			    CParticleQualities	; defaults = all 0.0
       Max			    CParticleQualities	; defaults = as defined in CParticleQualities customstruc definition
       lpEffectNameDesc 	    dd ?		; ??? *** pointer to struct containing pointer to instance's name... probably only during loading
       unknownInt		    dd ?		; ??? *** usually in the lower thousands... doesn't seem used
ends

; ** Don't know what this does. Seems to be 0.250000 for all CParticles instances.

; *** These aren't touched by the constructor. They seem to keep the values they had _before_
; the object was constructed. May be unused values altogether (the pointer becomes invalid after
; level load).
