;============================================================
ATXPROC GetInstanceFromString			; eax = instance's name, returns in eax (null if error)
;============================================================
; THIS FUNCTION IS COPIED ALMOST ENTIRELY FROM THE EXECUTABLE.
; IT IS POORLY CODED, BUT MOSTLY UNCHANGED FOR COMPATIBILITY
; WITH MAIN FUNCTION.
; GetInstanceFromStringGlobal should generally be used instead.
; GetInstanceFromString should be used during initialization only.
; GetInstanceFromStringGlobal may not return instances if it
; is called too early during loading (instances not initialized), which
; is when this *could* be used.

push esi
push ecx
push edx

	mov esi,eax
	ccall [YAPAXI],16     ; REPAIRED 2007/08/07 for CCALL macro

	test eax,eax
	     jz .notok

		push [GETINST_ADDR1]
		mov ecx,eax
		call [GETINST_PROC1]
		jmp .isok

	.notok:

		xor eax,eax

	.isok:

	push eax
	push 0
	sub esp,8
	mov ecx,esp
	push esi
	call [GETINST_PROC2]

	mov eax,[GETINST_ADDR2]
	mov edx,[eax]
	mov ecx,[edx+4]
	call [GETINST_PROC3]			; takes 4 parameters (push eax; push 0; sub esp,8)

pop edx
pop ecx
pop esi
ret

;============================================================
ATXPROC GetInstanceFromStringGlobal		; eax = pointer to string, returns instance in eax or null if not found
;============================================================
; should not be used in performance-critical areas where
; the second part of this function is to be called repeatedly
; on the same string ID (from the same string)

; GetInstanceFromStringGlobal may not return instances if it
; is called too early during loading (instances not initialized).

	test eax,eax
	     jz .exit

	GETNAMEID32STD eax
	GETINSTANCEFROMID32 eax

.exit:
ret

;============================================================
ATXPROC GetInstanceFromStringGlobal_CBD 	; eax = pointer to string, returns instance in eax or null if not found
;============================================================
; also check in CBackDrop buffer

push ebx

	test eax,eax
	     jz .exit

	GETNAMEID32STD eax
	mov ebx,eax

	GETINSTANCEFROMID32 ebx
	test eax,eax
	     jnz .exit

	mov eax,ebx
	call CBACKDROPFINDINSTANCEFROMID

.exit:
pop ebx
ret

;============================================================
ATXPROC IsValidInstance 			; param1 = mem pointer, param2 = mem size
;============================================================
; returns non-zero if valid (will use return value of IsValidInstance)

	cmp DWORD [esp+4],0
	    jz .invalid
	cmp DWORD [esp+8],0
	    jz .invalid

	invoke IsBadWritePtr,[esp+8],[esp+8]	; test for pointer validity
	test eax,eax
	     jnz .invalid

	invoke IsBadReadPtr,[esp+8],[esp+8]
	test eax,eax
	mov edx,[esp+4]
	     jnz .invalid

	mov ecx,[edx]
	call IsValidInstanceVTable		; test if first member is indeed a valid VTable (approximately, should always be true)

ret 8

.invalid:

	xor eax,eax

ret 8

;============================================================
ATXPROC IsTresClassInheritor
;============================================================
; ecx = VTable of instance (inheritor)
; edx = VTable of possibly inherited class
; returns eax = non-zero if is inheritor

push esi

	mov eax,[edx-4]
	mov ecx,[ecx-4]
	mov edx,[eax+0Ch]			; comparative pointer
	mov esi,[ecx+10h]
	mov ecx,[esi+8] 			; inheritance count
	mov esi,[esi+0Ch]			; base inheritance list

	.loop:
	mov eax,[esi]
	cmp [eax],edx
	    jz .found

	add esi,4
	dec ecx
	    jnz .loop

	xor eax,eax

pop esi
ret

.found:

	mov eax,TRUE

pop esi
ret