;================================================================
; macros, values, exe-specific values
;================================================================

_exe_P6_1_1_Size		equ	2555904 	; EXE sizes for detection
_exe_P5_1_1_Size		equ	2580480
_exe_K6_1_1_Size		equ	2351104
_exe_P5_Demo_Size		equ	2600960

virtual at esi
	freespace_addr		dd	?
	maincode_addr		dd	?
	entrypoint		dd	?
	entry_call		dd	?
	maincode_length 	dd	?
 label	exe_name
end virtual

; DO NOT MODIFY THIS STRUCTURE!!! MUST COINCIDE WITH SAME STRUCTURE
; OF ATYPEX.DLL SOURCE
struct ATX_EXIT_INFO
       lpFreeLibrary		dd	?
       ATXModuleHandle		dd	?
       lpExitProc		dd	?	; may be Kernel32.ExitProcess, MSVCRT.exit, or MSVCRT._exit
ends


;================================================================
MACRO WRITE_EXE_CODE file_offset,code_data,code_size,errortext {
;================================================================

	mov eax,file_offset
	sub eax,00400000h
	invoke SetFilePointer,ebx,eax,0,FILE_BEGIN

	invoke WriteFile,ebx,code_data,code_size,byteswritten,0
	mov ecx,[byteswritten]
	test eax,eax
	mov edi,errortext
	     jz MAINEXIT

	cmp ecx,code_size
	    jnz MAINEXIT

	}

;================================================================
MACRO MAIN_CODE _exitprocess,_loadlib,_freelib,\
		_msgbox,_getmoduleh,\
		_getprocaddr,_exitaddr,_exit2addr
;================================================================
{

	local Initialize,End_Initialize,Unload,\
	      _msgcapt,_msgtext1,_msgtext2,_msgtext3,_mxtname,\
	      _atxprocinit,\
	      CouldNotLoadATX

Initialize:

	push DWORD [_exitprocess]		; save ExitProcess address!!! (may be changed by ATYPEX.dll)
	push ecx				; save ecx and edx registers
	push edx				; (may not be necessary, ?)
	push 0					; for module handle of ATYPEX.dll **

	stdcall DWORD [_loadlib],_mxtname	; load ATYPEX.DLL
	test eax,eax
	mov ecx,_msgtext1
	     jz CouldNotLoadATX

	mov [esp],eax				; store module handle

	stdcall DWORD [_getprocaddr],eax,_atxprocinit
	test eax,eax
	mov ecx,_msgtext2
	     jz CouldNotLoadATX

; call initialization, if exists, and pass addresses
	stdcall eax,Unload,_exitprocess,_exitaddr,_exit2addr	; calls ATYPEXDllInit
	test eax,eax				; should always return TRUE
	     jz CouldNotLoadATX

	add esp,4				; remove module handle ***
	pop edx
	pop ecx
	add esp,4				; remove ExitProcess address

; exit init successfully

	pop eax 				; get return address in eax

	push ebp				; REPLACED CODE (at entry point) /*
	mov ebp,esp				;
	push 0FFFFFFFFh 			; */

	jmp eax 				; continue loading trespasser


CouldNotLoadATX:

	test ecx,ecx				; if ecx is null, we did not get a message from ATYPEX.dll
	     jnz @f				; even though init proc was called - use default
	mov ecx,_msgtext3
	@@:

	stdcall DWORD [_msgbox],0,ecx,_msgcapt,0

	pop eax 				; remove module handle (may also be null) **
	test eax,eax
	     jz @f
	stdcall DWORD [_freelib],eax
	@@:

	pop edx
	pop ecx
	pop eax 				; get ExitProcess address

	add esp,4				; remove return address
	stdcall eax,0				; call ExitProcess

End_Initialize:

_mxtname			db	"ATYPEX.DLL",0
_atxprocinit			db	"init",0

_msgcapt			db	"ATX Trespasser 2.00+ Error",0
_msgtext1			db	"Unable to find and load ATYPEX.dll.",0
_msgtext2			db	"Unable to find ATYPEX.dll main initialization function.",0Dh,0Ah
				db	"Please ensure that you have ATX 2.00 or higher installed.",0
_msgtext3			db	"Error during ATYPEX.dll initialization.",0Dh,0Ah
				db	"Please examine ATX_LOGFILE.txt for details.",0

align 16
Unload:
; called by ATX
; before this is called, ATYPEX.dll calls its main uninitialization procedure
; esp = start of ATX_EXIT_INFO struct (on stack)
; following structure is return address + exit code

	mov ecx,[esp+ATX_EXIT_INFO.ATXModuleHandle]
	mov eax,[esp+ATX_EXIT_INFO.lpFreeLibrary]
	stdcall eax,ecx 				; free ATYPEX.dll

	mov eax,[esp+ATX_EXIT_INFO.lpExitProc]
	add esp,sizeof.ATX_EXIT_INFO			; clean up stack
	jmp eax 					; exit



}
;================================================================