;================================================================
; macros, values, exe-specific values
;================================================================

_exe_P6_1_1_Size		equ	2555904 	; EXE sizes for detection
_exe_P5_1_1_Size		equ	2580480
_exe_K6_1_1_Size		equ	2351104
_exe_P5_Demo_Size		equ	2600960

virtual at esi
	freespace_addr		dd	?
	maincode_addr		dd	?
	entrypoint		dd	?
	entry_call		dd	?
	maincode_length 	dd	?
 label	exe_name
end virtual

; DO NOT MODIFY THIS STRUCTURE!!! MUST COINCIDE WITH SAME STRUCTURE
; OF ATYPEX.DLL SOURCE
struct ATX_EXIT_INFO
       lpFreeLibrary		dd	?
       ATXModuleHandle		dd	?
       lpExitProc		dd	?	; may be Kernel32.ExitProcess, MSVCRT.exit, or MSVCRT._exit
ends

DEMO_TEXT_DEST_ADDR		equ	0063EC56h
DEMO_SELFMOD_DEST_ADDR		equ	00401000h		 ;0064BCB5h
DEMO_ENTRYPOINT_ADDR		equ	0060C3D2h

;================================================================
MACRO WRITE_EXE_CODE file_offset,code_data,code_size,errortext {
;================================================================

	mov eax,file_offset
	sub eax,00400000h
	invoke SetFilePointer,ebx,eax,0,FILE_BEGIN

	invoke WriteFile,ebx,code_data,code_size,byteswritten,0
	mov ecx,[byteswritten]
	test eax,eax
	mov edi,errortext
	     jz MAINEXIT

	cmp ecx,code_size
	    jnz MAINEXIT

	}

;================================================================
; CD constants and macros
;================================================================

SEM_FAILCRITICALERRORS			equ	1h
SEM_NOGPFAULTERRORBOX			equ	2h
SEM_NOOPENFILEERRORBOX			equ	8000h
MAX_PATH				equ	260
ERROR_SUCCESS				equ	0

TEMP_BUF_SIZE				equ	128
MIN_CDROM_SIZE				equ	600000000
MAX_CDROM_SIZE				equ	750000000
CD_HDSERIAL_DISPVALUE			equ	40000

_exitprocess				equ	0064C158h
_loadlib				equ	0064C128h
_freelib				equ	0064C130h
_msgbox 				equ	0064C48Ch
_getmoduleh				equ	0064C0D8h
_getprocaddr				equ	0064C12Ch
_exitaddr				equ	0064C288h
_exit2addr				equ	0064C270h

_createfile				equ	0064C174h
_closehandle				equ	0064C178h
_getmodulefilename			equ	0064C160h
_getfileattributes			equ	0064C0C4h
_getfilesize				equ	0064C120h
_deletefile				equ	0064C0C0h
_regqueryvalueex			equ	0064C000h
_regsetvalueex				equ	0064C008h
_regclosekey				equ	0064C00Ch
_regcreatekey				equ	0064C014h
_findfirstfile				equ	0064C0E4h
_findclose				equ	0064C154h
_getlasterror				equ	0064C11Ch
_virtualalloc				equ	0064C118h
_virtualfree				equ	0064C114h

struct DemoAPICalls
       GetDriveType			dd	?
       GetLogicalDriveStrings		dd	?
       GetDiskFreeSpaceEx		dd	?
       GetVolumeInformation		dd	?
       SetErrorMode			dd	?
ends

struct DemoLV
       KernelModuleHandle		dd	?
       RegKeyHandle			dd	?
       RegKeyOpenInfo			dd	?
       RegValue1NameBuf 		db	32 dup ?
       RegKeyValueSize			dd	?
       RegKeyValueType			dd	?
       RegKeyValue			dd	?
       HDSerial 			dd	?
       APIs				DemoAPICalls
       finddata 			FINDDATA
       LargeInt1			dd	2 dup ?
       LargeInt2			dd	2 dup ?
       LargeInt3			dd	2 dup ?
       TempBuf				db	TEMP_BUF_SIZE dup ?
       TempBuf2 			db	TEMP_BUF_SIZE dup ?
ends

macro FINDSTRINGENDPOSTNULL reg1 {
      local scanloop,endscanloop

	scanloop:
	inc reg1
	cmp BYTE [reg1-1],0
	jnz scanloop

}

macro CHECKFILEONCD minfilesize,destjumpiferror {	; minfilesize > 0
	xor eax,eax
	call CDCheckDiscFile
	cmp eax,minfilesize
	jb destjumpiferror

; compare if modified/created dates are not same??? test for 1998???

}

MACRO GETPROCGETADDR addroffset {

	stdcall DWORD [_getprocaddr],[ebx+DemoLV.KernelModuleHandle],edi
	test eax,eax
	jz CDErrorExit
	mov [ebx+addroffset],eax

}

STRENC_ENCODE_CHAR	equ	20h
STRENC_END_CHAR 	equ	(not 0E8h)

macro STRENC strname,[data] {

	common
	strname:

	forward

	db (not (data-STRENC_ENCODE_CHAR))

	common
	db	STRENC_END_CHAR
}


;================================================================
MACRO MAIN_CODE
;================================================================
{

Initialize:

; Standard code /*
	push DWORD [_exitprocess]		; save ExitProcess address!!! (may be changed by ATYPEX.dll)
	push -1 				 ; for module handle of ATYPEX.dll **
; */

;==============================
; CD-ROM CHECK
;==============================

	push esi
	push edi
	push ebx
	push ebp
	mov ebp,esp
	xor ebx,ebx

	stdcall DWORD [_virtualalloc],0,sizeof.DemoLV,MEM_COMMIT+MEM_RESERVE,PAGE_READWRITE
	or eax,eax
	jz CDErrorExit
	mov ebx,eax

; initialize vars

	xor eax,eax
	mov [ebx+DemoLV.RegKeyHandle],eax
	mov [ebx+DemoLV.RegKeyValue],eax
	mov [ebx+DemoLV.HDSerial],eax

	jmp CDGetAPIProcAddresses
STRENC _CDbe130spz,			'd','a','t','a','\','b','e','-','1','3','0','.','s','p','z'
	CDGetAPIProcAddressesReturn:

	jmp CDGetMainKey
STRENC _CDRegKeyName,			'S','O','F','T','W','A','R','E','\','A','T','X',' ','2'
	CDGetMainKeyReturn:

	jmp CDUpdateRegKey

STRENC _CDGetDriveType, 		"G","e","t","D","r","i","v","e","T","y","p","e","A"

; Error - exit program (not validated)

	CDErrorExit:

	stdcall DWORD [_msgbox],0,_CDerrmsgbadproc,_CDmsgcapt,0

	CDExitSilent:

	call CDReleaseBuffer

	add esp,4				; remove module handle (n/a)
	pop eax 				; get ExitProcess address

	add esp,4				; remove return address
	stdcall eax,0				; call ExitProcess

STRENC _CDGetLogicalDriveStrings,	"G","e","t","L","o","g","i","c","a","l","D","r","i","v","e","S","t","r","i","n","g","s","A"

; continue game load (success)

	CDExitOK:

	call CDReleaseBuffer

;==============================
; continue
;==============================

; ORIGINAL CODE /*

	jmp LoadATYPEXDLL
	LoadATYPEXDLLReturn:

; call initialization, if exists, and pass addresses (MUST BE IN MAIN CODE, NOT SECONDARY!!! SAME FOR ANY CODE FOLLOWING!!!!!!!!!!!!)
	stdcall eax,Unload,_exitprocess,_exitaddr,_exit2addr	; calls ATYPEXDllInit
	test eax,eax				; should always return TRUE
	     jz CouldNotLoadATX

	add esp,8				; remove module handle *** AND ExitProcess address

; exit init successfully

	pop eax 				; get return address in eax

	push ebp				; REPLACED CODE (at entry point) /*
	mov ebp,esp				;
	push 0FFFFFFFFh 			; */

	jmp eax 				; continue loading trespasser


CouldNotLoadATX:

	test ecx,ecx				; if ecx is null, we did not get a message from ATYPEX.dll
	jnz @f					; even though init proc was called - use default
	mov ecx,_msgtext3
	@@:

	stdcall DWORD [_msgbox],0,ecx,_msgcapt,0

	pop eax 				; remove module handle (may also be null) **
	test eax,eax
	jz @f
	stdcall DWORD [_freelib],eax
	@@:

	pop eax 				; get ExitProcess address

	add esp,4				; remove return address
	stdcall eax,0				; call ExitProcess

_mxtname			db	"ATYPEX.DLL",0
_atxprocinit			db	"init",0

_msgcapt			db	"ATX Trespasser 2.00+ Error",0
_msgtext1			db	"Unable to find and load ATYPEX.dll.",0
_msgtext2			db	"Unable to find ATYPEX.dll main initialization function.",0Dh,0Ah
				db	"Please ensure that you have ATX 2.00 or higher installed.",0
_msgtext3			db	"Error during ATYPEX.dll initialization.",0Dh,0Ah
				db	"Please examine ATX_LOGFILE.txt for details.",0


align 16
Unload:
; called by ATX
; before this is called, ATYPEX.dll calls its main uninitialization procedure
; esp = start of ATX_EXIT_INFO struct (on stack)
; following structure is return address + exit code

	mov ecx,[esp+ATX_EXIT_INFO.ATXModuleHandle]
	mov eax,[esp+ATX_EXIT_INFO.lpFreeLibrary]
	stdcall eax,ecx 				; free ATYPEX.dll

	mov eax,[esp+ATX_EXIT_INFO.lpExitProc]
	add esp,sizeof.ATX_EXIT_INFO			; clean up stack
	jmp eax 					; exit

; */ ORIGINAL CODE

}
;================================================================

;================================================================
MACRO MAIN_CODESELFMOD
;================================================================
{

STRENC _CDGetDiskFreeSpaceEx,		"G","e","t","D","i","s","k","F","r","e","e","S","p","a","c","e","E","x","A"

CDGetAPIProcAddresses:

; get kernel module handle

	stdcall DWORD [_getmoduleh],_kernelname
	test eax,eax
	jz CDErrorExit
	mov [ebx+DemoLV.KernelModuleHandle],eax

; get proc addresses

	lea edi,[ebx+DemoLV.TempBuf]

	mov ecx,_CDGetDriveType
	call CDUnEncodeString
	GETPROCGETADDR DemoLV.APIs.GetDriveType

	mov ecx,_CDGetLogicalDriveStrings
	call CDUnEncodeString
	GETPROCGETADDR DemoLV.APIs.GetLogicalDriveStrings

	mov ecx,_CDGetDiskFreeSpaceEx
	call CDUnEncodeString
	GETPROCGETADDR DemoLV.APIs.GetDiskFreeSpaceEx

	mov DWORD [ebp+16],0		; HACK - DEFAULT MODULE HANDLE

	mov ecx,_CDGetVolumeInformation
	call CDUnEncodeString
	GETPROCGETADDR DemoLV.APIs.GetVolumeInformation

	mov ecx,_CDSetErrorMode
	call CDUnEncodeString
	GETPROCGETADDR DemoLV.APIs.SetErrorMode

	jmp CDGetAPIProcAddressesReturn

STRENC _CDstreamtpaname,		'd','a','t','a','\','S','t','r','e','a','m','.','t','p','a'

      ;-------------------------
	CDUnEncodeString:
      ;-------------------------
		; edi = dest buffer (only preserved)
		; ecx = string

		mov edx,edi

		CDUnEncodeStringLoop:
		mov al,[ecx]
		cmp al,STRENC_END_CHAR
		jz CDUnEncodeStringDone
		not al
		add al,STRENC_ENCODE_CHAR
		mov [edx],al
		inc ecx
		inc edx
		jmp CDUnEncodeStringLoop

	CDUnEncodeStringDone:
	mov BYTE [edx],0
	ret

STRENC _CDGetVolumeInformation, 	"G","e","t","V","o","l","u","m","e","I","n","f","o","r","m","a","t","i","o","n","A"

; check value from reg - compare to HD serial (slightly encoded)

 CDGetKeyValue:

		mov eax,[ebx+DemoLV.RegKeyValue]
		or eax,eax
		jz CDDoCheck

		sub eax,CD_HDSERIAL_DISPVALUE
		not eax
		cmp eax,[ebx+DemoLV.HDSerial]
		jz CDExitOK					; if success, skip rest

; CD check

	CDDoCheck:

		stdcall [ebx+DemoLV.APIs.SetErrorMode],SEM_FAILCRITICALERRORS+SEM_NOOPENFILEERRORBOX

		lea esi,[ebx+DemoLV.TempBuf2]
		stdcall [ebx+DemoLV.APIs.GetLogicalDriveStrings],TEMP_BUF_SIZE,esi
		or eax,eax
		jz CDCheckFail

		CDDriveCheckLoop:

		cmp BYTE [esi],0
		jz CDCheckFail

		stdcall [ebx+DemoLV.APIs.GetDriveType],esi
		cmp eax,DRIVE_CDROM
		jnz CDDriveNotCD

		lea eax,[ebx+DemoLV.LargeInt1]
		lea ecx,[ebx+DemoLV.LargeInt2]
		lea edx,[ebx+DemoLV.LargeInt3]
		stdcall [ebx+DemoLV.APIs.GetDiskFreeSpaceEx],esi,eax,ecx,edx
		or eax,eax
		jz CDDriveNotCD

		xor eax,eax
		mov ecx,[ebx+DemoLV.LargeInt2]
		or eax,[ebx+DemoLV.LargeInt1+4]
		or eax,[ebx+DemoLV.LargeInt2+4]
		or eax,[ebx+DemoLV.LargeInt3+4]
		or eax,[ebx+DemoLV.LargeInt1]
		or eax,[ebx+DemoLV.LargeInt3]
		jnz CDDriveNotCD

		cmp ecx,MIN_CDROM_SIZE
		jb CDDriveNotCD
		cmp ecx,MAX_CDROM_SIZE
		ja CDDriveNotCD

			; found CD drive - check for known files

			mov eax,[esi]
			mov DWORD [ebx+DemoLV.TempBuf],eax
			lea edi,[ebx+DemoLV.TempBuf+3]		; (put strings following "D:\")

			mov ecx,_CDtpassk6name
			call CDUnEncodeString
			CHECKFILEONCD 2100000,CDDriveNotCD

			mov ecx,_CDsetup95name
			call CDUnEncodeString
			CHECKFILEONCD 1500000,CDDriveNotCD

			mov ecx,_CDstreamtpaname
			call CDUnEncodeString
			CHECKFILEONCD 125000000,CDDriveNotCD

			mov ecx,_CDtpassintrosmkname
			call CDUnEncodeString
			CHECKFILEONCD 25000000,CDDriveNotCD

			mov ecx,_CDbe130spz
			call CDUnEncodeString
			CHECKFILEONCD 30000000,CDDriveNotCD

			mov ecx,_CDit130spz
			call CDUnEncodeString
			CHECKFILEONCD 55000000,CDDriveNotCD

			jmp CDCheckTestFile
			CDCheckTestFileReturn:



		CDDriveNotCD:

		FINDSTRINGENDPOSTNULL esi			; get next drive letter
		jmp CDDriveCheckLoop

	CDCheckFail:						; default = failure

	stdcall DWORD [_msgbox],0,_CDmsgtext1,_CDmsgcapt,MB_OKCANCEL
	cmp eax,IDOK
	jz CDDoCheck
	jmp CDExitSilent

	CDCheckSuccess:

		jmp CDGetMainKeyReturn

STRENC _CDSetErrorMode, 		"S","e","t","E","r","r","o","r","M","o","d","e"
STRENC _CDit130spz,			'd','a','t','a','\','i','t','-','1','3','0','.','s','p','z'

      ;-------------------------
	CDCheckDiscFile:
      ;-------------------------
	; returns NULL or file size

		lea eax,[ebx+DemoLV.finddata]
		lea edx,[ebx+DemoLV.TempBuf]
		stdcall DWORD [_findfirstfile],edx,eax
		cmp eax,INVALID_HANDLE_VALUE
		jz CDCheckDiscFile_error

		stdcall DWORD [_findclose],eax

		test [ebx+DemoLV.finddata.dwFileAttributes],FILE_ATTRIBUTE_READONLY
		jz CDCheckDiscFile_error

		cmp [ebx+DemoLV.finddata.nFileSizeHigh],0
		jnz CDCheckDiscFile_error

		mov eax,[ebx+DemoLV.finddata.nFileSizeLow]
		ret

		CDCheckDiscFile_error:
		xor eax,eax
		ret


_kernelname				db	"KERNEL32.DLL",0
_CDmsgcapt				db	"ATX2 Demo Validation (one time only)",0
_CDmsgtext1				db	"Please insert the Trespasser CD into your CD-ROM drive.",0	; ok, cancel
_CDerrmsgbadproc			db	"Failure during validation.",0

STRENC _CDtpassintrosmkname,		'd','a','t','a','\','m','e','n','u','\','t','p','a','s','s','i','n','t','r','o','.','s','m','k'

      ;-------------------------
	CDReleaseBuffer:
      ;-------------------------

		pop esi 		; return address

		or ebx,ebx
		jz CDNoRelease

		stdcall [ebx+DemoLV.APIs.SetErrorMode],0

		mov eax,[ebx+DemoLV.RegKeyHandle]
		test eax,eax
		jz @f
		stdcall DWORD [_regclosekey],eax
		@@:

		stdcall DWORD [_virtualfree],ebx,0,MEM_RELEASE

		CDNoRelease:

		mov eax,esi

		mov esp,ebp
		pop ebp
		pop ebx
		pop esi
		pop edi

		jmp eax


STRENC _CDtpassk6name,			's','e','t','u','p','\','t','p','a','s','s','k','6','.','e','x','e'


; get value from registry (DWORD)

CDGetMainKey:

; get hard drive volume serial number

	lea edx,[ebx+DemoLV.HDSerial]
	lea eax,[ebx+DemoLV.TempBuf]
	xor ecx,ecx
	mov DWORD [eax],'C:\'
	stdcall [ebx+DemoLV.APIs.GetVolumeInformation],eax,ecx,ecx,edx,ecx,ecx,ecx,ecx
	or eax,eax
	jz CDErrorExit
	cmp [ebx+DemoLV.HDSerial],0
	jz CDErrorExit

; open main registry key

	mov ecx,_CDRegKeyName
	call CDUnEncodeString

	lea ecx,[ebx+DemoLV.RegKeyHandle]
	stdcall DWORD [_regcreatekey],HKEY_LOCAL_MACHINE,edi,ecx
	or eax,eax					; ERROR_SUCCESS = 0
	jnz CDErrorExit

; open main key and read value

	lea eax,[ebx+DemoLV.RegValue1NameBuf]
	lea ecx,[ebx+DemoLV.RegKeyValueSize]
	lea edi,[ebx+DemoLV.RegKeyValueType]
	lea edx,[ebx+DemoLV.RegKeyValue]
	mov DWORD [eax],'UID'
	mov DWORD [ecx],4
	mov DWORD [edi],REG_DWORD
	stdcall DWORD [_regqueryvalueex],[ebx+DemoLV.RegKeyHandle],eax,0,edi,edx,ecx

	jmp CDGetKeyValue

STRENC _CDsetup95name,			's','e','t','u','p','\','s','e','t','u','p','9','5','.','e','x','e'

	CDCheckTestFile:

			mov DWORD [edi],"tst."
			mov DWORD [edi+4],"bin"

			stdcall DWORD [_createfile],edi,GENERIC_WRITE,FILE_SHARE_WRITE,0,0,CREATE_NEW,0
			cmp eax,INVALID_HANDLE_VALUE
			jz CDCheckSuccess

			stdcall DWORD [_closehandle],eax
			stdcall DWORD [_deletefile],edi
			jmp CDCheckTestFileReturn

; ORIGINAL CODE /*

LoadATYPEXDLL:
	stdcall DWORD [_loadlib],_mxtname	; load ATYPEX.DLL
	test eax,eax
	mov ecx,_msgtext1
	jz CouldNotLoadATX

	cmp DWORD [esp],0
	jnz CouldNotLoadATX

	mov [esp],eax				; store module handle

	stdcall DWORD [_getprocaddr],eax,_atxprocinit
	test eax,eax
	mov ecx,_msgtext2
	jz CouldNotLoadATX
	jmp LoadATYPEXDLLReturn

; */ ORIGINAL CODE

; reg key update/initialize

	CDUpdateRegKey:

		mov ecx,[ebx+DemoLV.HDSerial]
		not ecx
		add ecx,CD_HDSERIAL_DISPVALUE
		mov [ebx+DemoLV.RegKeyValue],ecx

		lea eax,[ebx+DemoLV.RegValue1NameBuf]
		lea edx,[ebx+DemoLV.RegKeyValue]
		stdcall DWORD [_regsetvalueex],[ebx+DemoLV.RegKeyHandle],eax,\
					       0,REG_DWORD,edx,4

	jmp CDExitOK			; success!

}