;compile using FASM (see "SOURCE_README.txt" for last version used)
;Use: Run VTABLEID.EXE and select a v1.1 Trespasser executable (don't
;try other executables -> may crash). A file of similar name but
;with "_AV.txt" appended (text file) will be created in the same directory.
;It will contain all of the ".?AV" class debug references and attempt
;to find each of their class VTables. The VTables are the addresses
;indented two tabs into the line; the other addresses are not useful.
;If a class name does not have a double-indented address (i.e., has only
;one address under it) or has no address at all, it simply means that
;the scan could not find a VTable for that "class".

VTABLEIDVERSION 	equ	'1.0'

format PE GUI 4.0
entry START
stack 20000h

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this

_exe_P6_1_1_Size	equ	2555904 	;EXE sizes for detection
_exe_P5_1_1_Size	equ	2580480
_exe_K6_1_1_Size	equ	2351104
_exe_P5_Demo_Size	equ	2600960

;For all Trespasser 1.1 EXE VTables (for most classes)
;DWORD [VTable-4] points to DebugObject1
;DWORD [DebugObject1+0Ch] points to ((?.AV-string address) - 8 )
;*****
;DWORD [((?.AV-string address) - 8 )] holds a one-member VTable which is the
;same for most or all AV-string addresses; most likely a class on its own (or the like).

MACRO TOMEMADDR reg1 {
      sub reg1,[source_exe_read]
      add reg1,[rdata_section_offset]
      add reg1,00400000h
      }

MACRO TOFILEADDR reg1 {
      sub reg1,00400000h
      sub reg1,[rdata_section_offset]
      add reg1,[source_exe_read]
      }

;=================================================================
section '.code' code readable executable
;=================================================================
START:
push ebp
push ebx
push edi
push esi

       mov [OFN_info.lStructSize],sizeof.OPENFILENAME
       mov [OFN_info.lpstrFilter],filter_strings
       mov [OFN_info.lpstrFile],source_exe_file
       mov [OFN_info.nMaxFile],512
       mov [OFN_info.lpstrDefExt],default_extension
       mov [OFN_info.lpstrTitle],open_file_caption
       mov [OFN_info.Flags],OFN_FILEMUSTEXIST+OFN_LONGNAMES+OFN_PATHMUSTEXIST+OFN_EXPLORER
invoke GetOpenFileName,OFN_info
       test eax,eax
	    jz MAINEXIT

       mov esi,source_exe_file
       mov edi,dest_txt_file
       call TransferString
       mov DWORD [edi-4],'_AV.'
       mov DWORD [edi],00747874h	;'txt',0

invoke CreateFile,source_exe_file,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL,0,0
       test eax,eax
       mov [source_exe_handle],eax
	   jz MAINEXIT
       cmp eax,-1
	   jz MAINEXIT

invoke GetFileSize,eax

       cmp eax,_exe_P6_1_1_Size
	   jnz Not_exe_P6_1_1_Size
	   mov [rdata_section_offset],DWORD 00242000h
	   mov [data_section_end],DWORD 0026A000h
	   mov [exe_type],DWORD 'P611'
	   jmp EXE_SIZE_VALID_A
       Not_exe_P6_1_1_Size:

       cmp eax,_exe_P5_1_1_Size
	   jnz Not_exe_P5_1_1_Size
	   mov [rdata_section_offset],DWORD 00248000h
	   mov [data_section_end],DWORD 00270000h
	   mov [exe_type],DWORD 'P511'
	   jmp EXE_SIZE_VALID_A
       Not_exe_P5_1_1_Size:

       cmp eax,_exe_K6_1_1_Size
	   jnz Not_exe_K6_1_1_Size
	   mov [rdata_section_offset],DWORD 00210000h
	   mov [data_section_end],DWORD 00238000h
	   mov [exe_type],DWORD 'K611'
	   jmp EXE_SIZE_VALID_A
       Not_exe_K6_1_1_Size:

       cmp eax,_exe_P5_Demo_Size
	   jnz Not_exe_P5_Demo_Size
	   mov [rdata_section_offset],DWORD 0024C000h
	   mov [data_section_end],DWORD 00275000h
	   mov [exe_type],DWORD 'DEMO'
	   jmp EXE_SIZE_VALID_A
       Not_exe_P5_Demo_Size:

       jmp EXE_INVALID

EXE_SIZE_VALID_A:

       mov eax,[data_section_end]
       sub eax,[rdata_section_offset]
       mov [source_read_size],eax
       add eax,4
invoke LocalAlloc,LMEM_FIXED,eax
       test eax,eax
       mov [source_exe_read],eax
	    jz MAINEXIT
       add eax,[source_read_size]
       sub eax,4
       mov [source_end_read_buf],eax
       mov DWORD [eax+4],0		;(for potential strings)


invoke SetFilePointer,[source_exe_handle],[rdata_section_offset],0,FILE_BEGIN
       cmp eax,-1
	   jz MAINEXIT

invoke ReadFile,[source_exe_handle],[source_exe_read],[source_read_size],temp_var,0
       test eax,eax
       mov ecx,[source_read_size]
	    jz MAINEXIT
       cmp ecx,[temp_var]
	   jnz MAINEXIT

invoke CreateFile,dest_txt_file,GENERIC_WRITE,0,0,CREATE_ALWAYS,\
			FILE_ATTRIBUTE_NORMAL,0,0
       test eax,eax
       mov [dest_txt_handle],eax
	   jz MAINEXIT
       cmp eax,-1
	   jz MAINEXIT

invoke wsprintf,temp_buf,TXT_INTRO,source_exe_file
       add esp,12

invoke WriteFile,[dest_txt_handle],temp_buf,eax,temp_var,0


       mov ebx,[source_exe_read]
       add ebx,(8-1)

;============================================================

;find type_info vtable
       mov edx,[source_end_read_buf]
       mov eax,(type_info_str_end-type_info_str)
       sub edx,eax

stdcall FindDataInBuffer,type_info_str,eax,\
			ebx,edx
       test eax,eax
	    jz END_AVSearchLoop
       mov edx,[eax-8]		;type_info VTable to search for
       mov [type_info_vtable],edx

;--------------------------------
;MAIN .?AV SEARCH LOOP
;--------------------------------
AVSearchLoop:
       inc ebx
       mov eax,[type_info_vtable]
       mov edi,ebx
       call FindDWORDInBuffer
       test edi,edi
       mov ebx,edi
	    jz END_AVSearchLoop

       mov ecx,ebx
       invoke type_info_name

       lea edx,[ebx+8]
invoke wsprintf,temp_buf,TXT_AVSTRING,eax,edx
       add esp,16

invoke WriteFile,[dest_txt_handle],temp_buf,eax,temp_var,0	  ;prints .?AV string

invoke free,[ebx+4]
       add esp,4
       mov DWORD [ebx+4],0

       inc [classcount]
;--------------------------------
;FIRST SUB-LOOP (FINDS POINTERS TO ((AV STRING ADDRESS) - 8) )
;--------------------------------
       mov edx,[source_exe_read]
       lea eax,[ebx]		;last reference address/offset
       add edx,(0Ch-1)
       TOMEMADDR eax
       mov [currADDR],edx
       mov [currADDRvalue],eax

   ADDRSearchLoop:
       mov edi,[currADDR]
       mov eax,[currADDRvalue]
       inc edi
       mov [currADDR],edi
       call FindDWORDInBuffer
       test edi,edi
       mov [currADDR],edi
	    jz AVSearchLoop

       sub edi,0Ch
       mov eax,edi
       mov edi,TXT_ADDRPART
       TOMEMADDR eax
       mov [currADDRSUBvalue],eax
       call Hex24ToASCII

invoke WriteFile,[dest_txt_handle],TXT_HEXADDR,(TXT_HEXADDR_END-TXT_HEXADDR),temp_var,0      ;prints address which [VTable-4] holds

;--------------------------------
;SECOND SUB-LOOP (FINDS VTABLE)
;--------------------------------
       mov edx,[source_exe_read]
       add edx,(-1)
       mov [currADDRSUB],edx

   ADDRSUBSearchLoop:
       mov edi,[currADDRSUB]
       mov eax,[currADDRSUBvalue]
       inc edi
       mov [currADDRSUB],edi
       call FindDWORDInBuffer
       test edi,edi
       mov [currADDRSUB],edi
	    jz ADDRSearchLoop

       mov eax,edi
       add eax,4
       mov edi,TXT_ADDRPARTSUB
       TOMEMADDR eax
       call Hex24ToASCII

invoke WriteFile,[dest_txt_handle],TXT_HEXADDRSUB,(TXT_HEXADDRSUB_END-TXT_HEXADDRSUB),temp_var,0      ;prints VTable base address

       inc [vtablecount]
       jmp ADDRSUBSearchLoop
;============================================================
END_AVSearchLoop:

invoke wsprintf,temp_buf,endcount_str,[classcount],[vtablecount]
invoke WriteFile,[dest_txt_handle],temp_buf,eax,temp_var,0


invoke MessageBox,0,error_success_1,msgbox_caption,0

MAINEXIT:
       mov eax,[source_exe_read]
       test eax,eax
	    jz Nosource_exe_read_handle_close
invoke LocalFree,eax
       Nosource_exe_read_handle_close:

       mov eax,[source_exe_handle]
       test eax,eax
	    jz Nosource_exe_handle_close
invoke CloseHandle,eax
       Nosource_exe_handle_close:

       mov eax,[dest_txt_handle]
       test eax,eax
	    jz Nodest_txt_handle_close
invoke CloseHandle,eax
       Nodest_txt_handle_close:

       pop esi
       pop edi
       pop ebx
       pop ebp
invoke ExitProcess,0

EXE_INVALID:
invoke MessageBox,0,error_invalid_exe,msgbox_caption,0
     jmp MAINEXIT
;============================================================
TransferString: 	;esi=source, edi=dest., destroyed: esi,edi, al
;============================================================
TransferStringLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[esi]
     mov [edi],al	      ;transfer/append string
     test al,al
	  jz End_TransferStringLoop
     inc esi
     inc edi
     jmp TransferStringLoop
End_TransferStringLoop:
ret

;============================================================
FindDWORDInBuffer:     ;eax = DWORD to find, edi = address to start looking from
;============================================================
		       ;returns ---- in EDI ---- address if found or NULL
	mov ecx,[source_end_read_buf]
	sub ecx,edi
FindDWORDInBufferLOOP:
	cmp [edi],eax
	    jz FindDWORDInBufferFOUND
	inc edi
	loop FindDWORDInBufferLOOP
	xor edi,edi
FindDWORDInBufferFOUND:
ret

;============================================================
Hex24ToASCII:	      ;edi = dest. string, eax = 24-bit hex value to notate
;============================================================
push ebx

	mov edx,eax
	mov ecx,eax
	shr edx,8
	shr ecx,16

	mov ebx,eax
	and eax,0Fh
	shr ebx,4
	mov al,[HEX_CONV_ARRAY+eax]
	and ebx,0Fh
	mov [edi+5],al
	mov al,[HEX_CONV_ARRAY+ebx]
	mov [edi+4],al

	mov ebx,edx
	and edx,0Fh
	shr ebx,4
	mov al,[HEX_CONV_ARRAY+edx]
	and ebx,0Fh
	mov [edi+3],al
	mov al,[HEX_CONV_ARRAY+ebx]
	mov [edi+2],al

	mov ebx,ecx
	and ecx,0Fh
	shr ebx,4
	mov al,[HEX_CONV_ARRAY+ecx]
	and ebx,0Fh
	mov [edi+1],al
	mov al,[HEX_CONV_ARRAY+ebx]
	mov [edi+0],al

pop ebx
ret

;============================================================
FindDataInBuffer:
;============================================================
;[esp+4] = pointer to data to find, [esp+8] = size of data buffer
;[esp+12] = address to start looking from, [esp+16] = max address
;returns address of found data in eax or NULL if not found
push ebp
mov ebp,esp
push esi
push edi
push ebx

	mov ebx,[ebp+20]
	mov edx,[ebp+16]
	sub ebx,[ebp+12]
	xor eax,eax
	cmp ebx,edx
	    jna FindDataInBuffer_EXIT

FindDataInBuffer_LOOP:
	mov esi,edx
	mov edi,[ebp+8]
	mov ecx,[ebp+12]
	repz cmpsb
	     jnz FindDataInBuffer_FOUND_NOT
	test ecx,ecx
	     jz FindDataInBuffer_FOUND
	FindDataInBuffer_FOUND_NOT:
	inc edx
	cmp edx,ebx
	    jb FindDataInBuffer_LOOP

	xor eax,eax

FindDataInBuffer_EXIT:
pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret 16

FindDataInBuffer_FOUND:
	mov eax,edx
jmp FindDataInBuffer_EXIT

;=================================================================
section '.data' data readable writeable
;=================================================================

msgbox_caption	     db      "Trespasser VTable identifier",0
OFN_info	     OPENFILENAME
OFN_info_2	     OPENFILENAME

filter_strings	     db      "Executable files",0,"*.exe",0
		     db      "All files",0,"*.*",0,0
default_extension    db      "exe",0
open_file_caption    db      "Trespasser VTable identifier - select executable",0

source_exe_file      db      512 dup 0
dest_txt_file	     db      512 dup 0
source_exe_handle    dd      0
source_exe_read      dd      0
source_read_size     dd      0
source_end_read_buf  dd      0

TXT_INTRO	     db      "Trespasser executable object class VTable identification",0Dh,0Ah
		     db      "Executable filename: %s",0Dh,0Ah
		     db      "Executable type: "
exe_type	     dd      0
		     db      0Dh,0Ah,0
TXT_AVSTRING	     db      0Dh,0Ah
		     db      "%s",0Dh,0Ah
		     db      09h,09h,"-> mangled name: %s",0Dh,0Ah
		     db      0
TXT_HEXADDR	     db      09h,"-> ref: 0x00"
TXT_ADDRPART	     db      "000000",0Dh,0Ah
     TXT_HEXADDR_END:
TXT_HEXADDRSUB	     db      09h,09h,"-> vtable: 0x00"
TXT_ADDRPARTSUB      db      "000000",0Dh,0Ah
     TXT_HEXADDRSUB_END:


currADDR	     dd      0
currADDRvalue	     dd      0
currADDRSUB	     dd      0
currADDRSUBvalue     dd      0

HEX_CONV_ARRAY	     db      "0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F"


temp_buf	     db      2000 dup 0


temp_var	     dd      0
dest_txt_handle      dd      0

rdata_section_offset dd      0
data_section_end     dd      0



filesize		dd	0
byteswritten		dd	0

error_invalid_exe    db      "Error: Not a v1.1 Trespasser executable",0
error_success_1      db      "File scanned.",0

type_info_str	     db      ".?AVtype_info@@",0
   type_info_str_end:

align 4
type_info_vtable     dd 	0
classcount	     dd 	0
vtablecount	     dd 	0

endcount_str	     db 	0Dh,0Ah
		     db 	";=======================================",0Dh,0Ah
		     db 	"Total class name/type descriptor count: %u",0Dh,0Ah
		     db 	"Total VTable count: %u",0Dh,0Ah
		     db 	";=======================================",0Dh,0Ah
		     db 	0


;=================================================================
section '.idata' import data readable writeable
;=================================================================
  library kernel,'KERNEL32.DLL',\
	  msvcrt,'MSVCRT.DLL',\
	  user,'USER32.DLL',\
	  comdlg,'COMDLG32.DLL'

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CreateFile,"CreateFileA",\
	 ExitProcess,"ExitProcess",\
	 GetFileSize,"GetFileSize",\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 ReadFile,"ReadFile",\
	 SetFilePointer,'SetFilePointer',\
	 WriteFile,'WriteFile'

  import msvcrt,\
	 type_info_constr,"??1type_info@@UAE@XZ",\
	 type_info_name,"?name@type_info@@QBEPBDXZ",\
	 free,"free",\
	 msize,"_msize",\
	 rand,"rand",\
	 sprintf,"sprintf",\
	 srand,"srand",\
	 sscanf,"sscanf",\
	 time,"time",\
	 YAPAXI,"??2@YAPAXI@Z"

  import user,\
	 MessageBox,'MessageBoxA',\
	 wsprintf,"wsprintfA"

  import comdlg,\
	 GetOpenFileName,'GetOpenFileNameA'

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_VERSION,versions

	resource versions,\
	   1,LANG_NEUTRAL,version

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','Trespasser VTable and Class identifier',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',VTABLEIDVERSION,\
	  'ProductVersion',VTABLEIDVERSION,\
	  'OriginalFilename','VTABLEID.exe'

